﻿<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
    <title>Свойства и методы</title>

    <script>
        function Point(x, y) {
            /*
                   {}  !== Object
                   {} ===  Point > Object
            */
            // свойства экземпляра
            this.x = x;
            this.y = y;
            // MaxPointCount1 = 540
            //Point.MaxPointCount++


            // метод экземпляра
            this.print = function () {
                document.write("(" + this.x + ", " + this.y + ")<br />");
            }
        }

        // свойство функции конструктора (аналог статических свойств).
        Point.MaxPointCount = 100;

        // Метод функции-конструктора (аналог статическгого метода).
        Point.getOrigin = function () {
            return new Point(0, 0) // this использовать недопустимо.
        }

        // создание экземпляров и работа с свойствами и методами экземпляров.
        var p1 = new Point(100, 200);
        p1.x = 300;
        p1.y = 400;
        p1.print();

        var p2 = new Point(100, 200);
        p2.print();

        // работа с свойством и методом функции-конструктора.
        Point.MaxPointCount = 10;
        Point.getOrigin().print();

        /*[new Point(),new Point(),new Point(),new Point(), ].sort((a, b) => {
            a - b
        })*/
/*
        const user = {
            name : "Ivan"
        }

        function  fn ({name}) {
          console.log(param.name) 
          console.log(name)
        }

        fn(user)


const a = (...arr) => {
console.log(arr)
}
a(1,2,3,4,5)
*/

class Human {
    constructor(userName) {
        this.name = userName
    }
    method () {
        
    }
    static name () {

    }
}
window.onload = () => {
   const div = document.querySelectorAll("div .class") 
}


    </script>




</head>

<body>

    <div></div>
</body>

</html>